传送门
文章目录
- 题意:
- 思路:
题意:
给你两个串s,ts,ts,t,每次都可以从sss的开头拿一个字符放到AAA串的开头或结尾,问最终有多少种方案使得ttt是AAA的前缀,注意sss不必全部拿完。
m,n≤3000m,n\le3000m,n≤3000
思路:
分析一下题目的性质,每次都给一个串从前面或从后面加一个字符,相当于从两边扩展长度,可以联想到区间dpdpdp。
设f[l][r]f[l][r]f[l][r]表示用sss的前r−l+1r-l+1r−l+1个字符拼成ttt的[l,r][l,r][l,r]的方案数,有一个很明显的转移方程:f[l][r]+=f[l+1][r](s[len]==t[l])f[l][r]+=f[l+1][r](s[len]==t[l])f[l][r]+=f[l+1][r](s[len]==t[l])f[l][r]+=f[l][r−1](s[len]==t[r])f[l][r]+=f[l][r-1](s[len]==t[r])f[l][r]+=f[l][r−1](s[len]==t[r])
直接这么写是不对的,因为我们发现s,ts,ts,t的长度不相等,也就是说如果len>mlen>mlen>m的话,有一部分放的时候是没有要求的,具体来说:
(1)(1)(1)当l>ml>ml>m的时候,它可以放在lll的位置,也可以放在rrr的位置。
(2)(2)(2)当r>mr>mr>m的时候,它可以放在rrr的位置。
所以转移的时候判断一下这两个条件就好啦。
初始的时候f[i][i]=2∗(i>m∣∣s[1]==t[i])f[i][i]=2*(i>m||s[1]==t[i])f[i][i]=2∗(i>m∣∣s[1]==t[i])。
最终答案为∑i=mnf[1][i]\sum_{i=m}^nf[1][i]∑i=mnf[1][i]。
// Problem: C. Kaavi and Magic Spell
// Contest: Codeforces - Codeforces Round #635 (Div. 1)
// URL: https://codeforces.com/problemset/problem/1336/C
// Memory Limit: 512 MB
// Time Limit: 2000 ms
//
// Powered by CP Editor (https://cpeditor.org)//#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2,popcnt,tune=native")
//#pragma GCC optimize(2)
#include<cstdio>
#include<iostream>
#include<string>
#include<cstring>
#include<map>
#include<cmath>
#include<cctype>
#include<vector>
#include<set>
#include<queue>
#include<algorithm>
#include<sstream>
#include<ctime>
#include<cstdlib>
#define X first
#define Y second
#define L (u<<1)
#define R (u<<1|1)
#define pb push_back
#define mk make_pair
#define Mid (tr[u].l+tr[u].r>>1)
#define Len(u) (tr[u].r-tr[u].l+1)
#define random(a,b) ((a)+rand()%((b)-(a)+1))
#define db puts("---")
using namespace std;//void rd_cre() { freopen("d://dp//data.txt","w",stdout); srand(time(NULL)); }
//void rd_ac() { freopen("d://dp//data.txt","r",stdin); freopen("d://dp//AC.txt","w",stdout); }
//void rd_wa() { freopen("d://dp//data.txt","r",stdin); freopen("d://dp//WA.txt","w",stdout); }typedef long long LL;
typedef unsigned long long ULL;
typedef pair<int,int> PII;const int N=3010,mod=998244353,INF=0x3f3f3f3f;
const double eps=1e-6;char a[N],b[N];
LL f[N][N];int main()
{
// ios::sync_with_stdio(false);
// cin.tie(0);scanf("%s%s",a+1,b+1);int n=strlen(a+1),m=strlen(b+1);for(int i=1;i<=n;i++) if(i>m||a[1]==b[i]) f[i][i]=2;for(int len=2;len<=n;len++) {for(int l=1;l+len-1<=n;l++) {int r=l+len-1;if(l>m||a[len]==b[l]) f[l][r]+=f[l+1][r]; f[l][r]%=mod;if(r>m||a[len]==b[r]) f[l][r]+=f[l][r-1]; f[l][r]%=mod;}}LL ans=0; for(int i=m;i<=n;i++) ans+=f[1][i],ans%=mod;printf("%d\n",ans%mod);return 0;
}
/**/